      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      INCLUDE 'APSCOM5.'
      INCLUDE 'PDFCOM.'

      real*8 q2h1(11)
      data q2h1 /2d0, 4d0, 6.5d0, 12d0, 20d0, 35d0
     ,    ,6d1, 1.2d2, 2d2, 4d2, 1d3/

#ifdef TOYLH
      print *,'******THIS BENCH IS INAPPLICABLE FOR THE TOYLH PDFS'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

! set c-quark mass
      rmass(8)=1.5d0

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2
      call pdffillgrid

!  Set the factorization scale as sqrt(Q2*hqscale1 + 4m^2*hqscale2)
      hqscale1=1d0
      hqscale2=1d0

! benchmark output of F_2,cc

      print *,'The c-quark semi-inclusive structure functions F_2^cc', 
     -' (first column: momentum transferred in GeV^2,',
     -' second column: x, third column: 3-flavour FFNS value of F_2^cc',
     -' at the NNLO, 4-th column: the same at NLO' 

      bmin=1d-5
      bmax=0.1
      nbin=30
      bin=(log(bmax)-log(bmin))/(nbin-1)

      do n=1,11
        q2=q2h1(n)
        do nn=1,nbin
          xb=bmin*exp(bin*(nn-1))
          kordhq=2                                !   O(\alpha_s^3)
          a1=f2charm_ffn(xb,q2,8)
          kordhq=1                                !   O(\alpha_s^2)
          a2=f2charm_ffn(xb,q2,8)
          write (*,fmt='(6e13.4)') q2,xb,a1,a2
        end do
      end do

      stop
      end
