!      PROGRAM EXAMPLE
* -------------------------------------------------------------------
* M. Wobisch 04/05/2006
*
* fastNLO - example program to call fastNLO calculations
*           for different scenarios using PDFs from LHAPDF
*
* the user needs to set the correct path to the PDFs in LHAPDF
* 
* -------------------------------------------------------------------

c - Attention!!! - the following arrays must be declared consistent 
c                  with their definitions in the commonblocks 
c                  in the scenario-specific include-files: fn[xxxxx].inc
      double precision 
     +     xst1001(33,3),
     +     xst1002(90,3),
     +     xst1003(51,3),
     +     xst1004(20,3),
     +     xst1005(20,3),
     +     xst1007(18,3),
     +     xst1008(15,3),
     +     xst2001(94,3),
     +     xst2002(20,3),
     +     xst2003(17,3),
     +     xst2007(77,3),
     +     xst2009(110,3),
     +     xsl0004(103,3),
     +     xsr0001(12,3),
     +     xsh1001(60,3),
     +     xsh1002(30,3),
     +     xsh1003(19,3),
     +     xsh1004(16,3)

      character name*80
      INCLUDE 'PDFCOM.'

c - compute the cross sections
      write(*,*) ' ******************************************************'
      write(*,*) '     fastNLO: call user codes for different scenarios'
      write(*,*) ' ******************************************************'
      write(*,*) ' '

c- new call: a single call for each scale
c         1st argument:  name of table
c         2nd argument:  xmur  prefactor for nominal ren-scale
c                              any choice is possible, but please note 
c                              that NNLO-NLL works only for xmur=xmuf
c         3rd argument:  xmuf  prefactor for nominal fact-scale
c                              only a few choices are possible
c                              (see output or table documentation)
c         4th argument:  0: no ascii output       1: print results
c         5th argument:  array to return results
c
c - the results of the last call can be accessed  
c   in the array:  xst1001(n,iord)
c      n: continuous bin number 
c   iord: order  1 LO, 
c                2 NLO correction (add 1,2 to get the NLO x-section)
c                3 2-loop threshold correction
c         (add 1,2,3 to get full prediction)

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 5-flavour NLO PDFs
      kschemepdf=2
      kordpdf=1
      kpdfset=0
      call pdffillgrid

      CALL GETENV( 'GRIDS', name )
      name=name(:LNBLNK(name))//'fastnlo/fnt2007midp.tab'
      call FX9999CC(name,1.0d0 ,1.0d0, 1,XST2007)

      END

