      implicit real*8 (a-h,o-z)

      INCLUDE 'CONSTCOM.'
      INCLUDE 'APSCOM5.'
      INCLUDE 'PDFCOM.'

      real*8 termplus(10,0:50,100),termtotplus(10,0:50,100)
     ,      ,termdisp(10,100)

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 5-flavour NNLO PDFs
      kschemepdf=2
      kordpdf=2

!  Set the factorization scale at the W mass
      rmuf=80.398

      do kpdfset=0,npdftot
!  Fill the PDF grid for the set #kpdfset
        call pdffillgrid

!  Loop over x
        do i=1,40
          xb=i*0.02d0

!  Fill the parton distributions
          do klum=1,4
! valence u-quarks
            if (klum.eq.1) termplus(klum,kpdfset,i)
     =   =xqg(4,xb,rmuf**2,kschemepdf)-xqg(5,xb,rmuf**2,kschemepdf)
! valence d-quarks
            if (klum.eq.2) termplus(klum,kpdfset,i)
     =   =xqg(2,xb,rmuf**2,kschemepdf)-xqg(3,xb,rmuf**2,kschemepdf)
! sea u-quarks
            if (klum.eq.3) termplus(klum,kpdfset,i)
     =   =xqg(5,xb,rmuf**2,kschemepdf)
! sea d-quarks
            if (klum.eq.4) termplus(klum,kpdfset,i)
     =   =xqg(3,xb,rmuf**2,kschemepdf)
          end do
        end do
      end do

      print *,' The parton distributions with uncertainties at the', 
     -' scale of the W-mass (first column: the Bjorken variable x,',
     -' second column: valence up-quark, third column: valence d-quark',
     -' fourth column: sea up-quark, fifth column: sea d-quark).'

      do i=1,40
        xb=i*0.02d0

        do klum=1,4
          termdisp(klum,i)=0.

          do kpdfset=1,npdftot          
            termdisp(klum,i)=termdisp(klum,i)
     +    +(termplus(klum,kpdfset,i)-termplus(klum,0,i))**2
          enddo  
!  In the case of asymmetric PDF errors 
!  take average of the positive and negative ones  
#if defined(ABKM09) || defined(ABKM09M)
          termdisp(klum,i)=sqrt(termdisp(klum,i))
#else
          termdisp(klum,i)=sqrt(termdisp(klum,i)/2.)
#endif

        end do

        write (*,fmt='(e13.4,4(e13.4,a2,e10.4))') xb
     ,        ,(termplus(kk,0,i),'+-',termdisp(kk,i),kk=1,4)
      end do

      stop
      end
