      implicit real*8 (a-h,o-z)

      INCLUDE 'CONSTCOM.'
      INCLUDE 'APSCOM5.'
      INCLUDE 'PDFCOM.'

!  The commons to transfer parameters to the W/Z rate code
      COMMON/SET/NZP,NWM,NWB,NCONST,NFRS
      COMMON/COLLISION/BEAM,TARGET
      COMMON/ANGLE/SINW,COSW,SINC,COSC
      COMMON/ORDE/NORDER
      common /forwzrates/ nfl
      INTEGER BEAM,TARGET

      real*8 termplus(10,0:50,100),termtotplus(10,0:50,100)
     ,      ,termdisp(10,100)
      real*8 TERM(20)

!  Set up constants, grid spacing, etc.
      call initgridconst

! Transfer the CKM matrix elements to the W/Z rate code
      sinc=ckm(2,1)**2            !  u-s  mixing
      cosc=ckm(1,1)**2            !  u-d  mixing 
!  
      nfl=4                       !  the 4-flavour scheme used 
      norder=2                    !  the NNLO coefficient functions 
!  Set the constants for the W/Z rate code
      call wzrateinit

!  Set up the NNLO PDFs in the proper scheme and order
      kschemepdf=nfl-3
      kordpdf=norder

      npoint=8                 ! (8 options for the beam type and energy:
                               ! SPPS (546 and 630 GeV), RHIC (400 GeV), 
                               ! FNAL(1.8 and 1.96 TeV), LHC (7, 10, and 14 TeV)
      nproc=4                  ! (4 processes: Z, W+-, W+, W- production)

      do kpdfset=0,npdftot
!  Fill the PDF grid for the set #kpdfset
        call pdffillgrid
        do kpoint=1,npoint
!  Set the beam, target, and the collision energy
          if (kpoint.eq.1) then 
!  SPPS, 546 GeV
            beam=2    
            target=1  
            sqrts=546d0 
          end if  
          if (kpoint.eq.2) then 
!  SPPS, 630 GeV
            beam=2    
            target=1  
            sqrts=630d0 
          end if  
          if (kpoint.eq.3) then 
!  FNAL, 1.8 TeV
            beam=2    
            target=1  
            sqrts=1800d0 
          end if  
          if (kpoint.eq.4) then 
!  FNAL, 1.96 TeV
            beam=2    
            target=1  
            sqrts=1960d0 
          end if  
          if (kpoint.eq.5) then 
!  RHIC, 500 GeV
            beam=1    
            target=1  
            sqrts=500d0
          end if  
          if (kpoint.eq.6) then 
!  LHC, 7 TeV
            beam=1    
            target=1  
            sqrts=7d3
          end if  
          if (kpoint.eq.7) then 
!  LHC, 10 TeV
            beam=1    
            target=1  
            sqrts=10d3
          end if  
          if (kpoint.eq.8) then 
!  LHC, 14 TeV
            beam=1    
            target=1  
            sqrts=14d3
          end if  
!  Set the final state
          do kproc=1,nproc
!  W+- rate
            if (kproc.eq.1) then 
              nzp=0
              nwb=1
            end if 
!  W+ rate
            if (kproc.eq.2) then 
              nzp=0
              nwb=0
              nwm=0
            end if 
!  W- rate
            if (kproc.eq.3) then 
              nzp=0
              nwb=0
              nwm=1
            end if 
!  Z rate
            if (kproc.eq.4) then 
              nzp=1
              nwb=0
            end if 
!  Call the W/Z rate code
            CALL KEUZE(SQRTS)
            CALL DSNEDE(TERM)
!  Sum the terms
            termplus(kproc,kpdfset,kpoint)=0.
            do kk=1,10
              termplus(kproc,kpdfset,kpoint)=
     =        termplus(kproc,kpdfset,kpoint)+term(kk)
            end do
            print *,termplus(kproc,kpdfset,kpoint)
          end do
        end do
      end do

      print *,'The rates of the IVBs at the hadron colliders (pb)',
     -' (first column: sum of W+ and W-, second column: W+,', 
     -' third column: W-, 4-th column: Z;',
     -' first line: SPPS(546 GeV), second line: SPPS(630 GeV),',
     -' third line: FNAL(1.8 TeV), 4-th line: FNAL(1.96 TeV),', 
     -' 5-th line: RHIC(500 GeV), 6-th line: LHC(7 TeV),', 
     -' 7-th line: LHC(10 TeV), 8-th line: LHC(14 TeV))' 

      do kpoint=1,npoint
        do kproc=1,nproc
          termdisp(kproc,kpoint)=0.
          do kpdfset=1,npdftot
            termdisp(kproc,kpoint)=termdisp(kproc,kpoint)
     +      +(termplus(kproc,kpdfset,kpoint)
     -      -termplus(kproc,0,kpoint))**2
          end do
!  In the case of asymmetric PDF errors
!  take average of the positive and negative ones
#if defined(ABKM09) || defined(ABKM09M)
!  Symmetric errors
          termdisp(kproc,kpoint)=sqrt(termdisp(kproc,kpoint))
#else
!  Asymmetric errors stored by pairs
          termdisp(kproc,kpoint)=sqrt(termdisp(kproc,kpoint)/2.)
#endif
        end do

        write (*,fmt='(4(e13.4,a2,e10.4))') 
     ,   ,(termplus(kk,0,kpoint),'+-',termdisp(kk,kpoint),kk=1,4)

      end do

      stop 
      end 
